<?php

	require_once("webapp_auth_common.php");
	require_once('../config.php');

	// WebApp stuff, needed for styling/theming
	// Change the working directory, so config.php will include
	// debug.php.
	$cwd = getCwd();
	chdir(WEBAPP_BASE_PATH);
	require_once(WEBAPP_BASE_PATH . "init.php");
	require_once(WEBAPP_BASE_PATH . "config.php");
	require_once(WEBAPP_BASE_PATH . "defaults.php");
	require_once(WEBAPP_BASE_PATH . "server/includes/core/class.theming.php");
	require_once(WEBAPP_BASE_PATH . "server/includes/core/class.webappauthentication.php");
	chdir($cwd);

	$webappDomain = PLUGIN_SPREEDWEBRTC_WEBAPP_DOMAIN ? PLUGIN_SPREEDWEBRTC_WEBAPP_DOMAIN : '';
	$theme = Theming::getActiveTheme();

	require("zarafa_session.php");
	require_once('jsconfig.php');

	$user = sanitizeGetValue('user', '', USERNAME_REGEX);
	$meetingid = sanitizeGetValue('meetingid', '', MEETINGID_REGEX);
	$email = sanitizeGetValue('email', '', ALLOWED_EMAIL_CHARS_REGEX);
	if (isset($_GET['displayname'])) {
		$displayname = htmlspecialchars($_GET['displayname']);
	} else {
		$displayname = '';
	}

	$url = '?logon&noredirect';
	foreach($_GET as $key => $value) {
		if(!empty($key) && !in_array($key, array('logon', 'load'))){
			$url.= '&' . $key;
			if(!empty($value)) {
				$url.= '=' . urlencode($value);
			}
		}
	}

	header("Content-type: text/html; charset=utf-8");
?><!DOCTYPE HTML>
<html>
	<head>
		<meta name="Generator" content="Kopano WebApp">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>Kopano WebApp Auth</title>
		<link rel="stylesheet" type="text/css" href="<?php echo $webappDomain.PLUGIN_SPREEDWEBRTC_WEBAPP_URL ?>client/resources/css/external/login.css">
		<link rel="stylesheet" type="text/css" href="../resources/css/login.css">
		<link rel="icon" href="../../../client/resources/images/favicon.ico" type="image/x-icon">
		<link rel="shortcut icon" href="../../../client/resources/images/favicon.ico" type="image/x-icon">

		<?php
			/* Add the styling of the theme */
			$css = Theming::getCss($theme);
			foreach ( $css as $file ){
				echo '<link rel="stylesheet" type="text/css" href="'.$webappDomain.PLUGIN_SPREEDWEBRTC_WEBAPP_URL.$file.'">';
			}
		?>

		<script src="../js/jquery-1.6.2.min.js"></script>
		<script type="text/javascript">
		    <?= PLUGIN_SPREEDWEBRTC_JS_CONFIG ?>
			window.onload = function(){
				if (document.getElementById("username").value == ""){
					document.getElementById("username").focus();
				}else if (document.getElementById("password").value == ""){
					document.getElementById("password").focus();
				} else {
					document.getElementById("submitbutton").focus();
				}
			}
		</script>
	</head>
	<body class="login theme-<?php echo strtolower($theme ? $theme : 'basic') ?>">
		<div id="form-container">
			<div id="bg"></div>
			<div id="content">
				<div class="left">
					<div id="logo"></div>
					<h1>Web Meetings</h1>
					<div id="wm-logo"></div>
				</div>
				<div class="right">
					<form action="../../../index.php<?= $url ?>" method="post" id="joinForm">
						<h2><?php echo dgettext('plugin_webmeetings', 'Please join web meetings'); ?></h2>
						<input type="text" name="meetingid" id="meetingid" placeholder="Meeting Id" class="inputelement" value="<?= $meetingid ?>">

						<input type="text" name="email" id="email" placeholder="E-mail" class="inputelement" value="<?= $email ?>">

						<input type="text" name="displayname" id="displayname" placeholder="Display name" class="inputelement" value="<?= $displayname ?>">

						<div id="error" class="join"></div>

						<input id="submitbutton" class="button" type="submit" value="<?php echo dgettext('plugin_webmeetings', 'Join meeting'); ?>">
					</form>
					<form action="../../../kopano.php?service=authenticate" method="post" id="loginForm">
						<h2><?php echo dgettext('plugin_webmeetings', 'or sign in with your Kopano account'); ?></h2>
						<input type="text" name="username" id="username" placeholder="<?php echo dgettext('plugin_webmeetings', 'Username'); ?>" value="<?php echo $user; ?>">

						<input type="password" name="password" id="password" placeholder="<?php echo dgettext('plugin_webmeetings', 'Password'); ?>" >

						<div id="error" class="logon"></div>

						<input id="submitbutton" class="button" type="submit" value="<?php echo dgettext('plugin_webmeetings',  'Sign in'); ?>">
					</form>
				</div>
			</div>
		</div>
		<script type="text/javascript">
			const cntEl = document.getElementById('form-container');

			//The sayswho functions is used in the resize.js script below, so we just copied it from
			// the fingerprint.js script
			navigator.sayswho = (function(){
				var ua= navigator.userAgent, tem,
				M= ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
				if(/trident/i.test(M[1])){
					tem=  /\brv[ :]+(\d+)/g.exec(ua) || [];
					return 'MSIE '+(tem[1] || '');
				}
				if(M[1]=== 'Chrome'){
					tem= ua.match(/\b(OPR|Edge)\/(\d+)/);
					if(tem!= null) return tem.slice(1).join(' ').replace('OPR', 'Opera');
				}
				M= M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
				if((tem= ua.match(/version\/(\d+)/i))!= null) M.splice(1, 1, tem[1]);

				return M.join(' ');
			})();
		</script>
		<script type="text/javascript"><?php require(WEBAPP_BASE_PATH . 'client/resize.js'); ?></script>

		<script>
		$("#joinForm").submit(function(event) {
			event.preventDefault();
			cntEl.classList.add('loading');
			var $form = $(this),
				meetingid = $form.find( "input[name='meetingid']" ).val(),
				displayname = $form.find( "input[name='displayname']" ).val(),
				email = $form.find( "input[name='email']" ).val(),
				url = config.webappAuthAuthenticationUrl;
			var posting = $.post( url, {
				meetingid: meetingid,
				displayname: displayname,
				email: email,
				client_id: 'zarafa_webmeetings',
				client_secret: ''
			});
			posting.done(function( data, textStatus, xhr ) {
				console.log( data );
				if(typeof data =='object') {
					console.log("success JSON");
				}
				var IS_JSON = true;
				var json;
				try
				{
				       json = $.parseJSON(data);
				}
				catch(err)
				{
				       IS_JSON = false;
				}
				if(IS_JSON) {
					console.log("success JSON text");
					parent.postMessage({
						type: "loginSuccess",
						loginSuccess: {
							type: 'code',
							code: data.code
						}
					},
					config.spreedDomain);
				} else {
					// TODO json errors handling
					console.log("authenticate failed");
					console.log(jQuery(data).find('p.error').html());
					$('#error.logon').html('');
					$('#error.join').html(error);
					cntEl.classList.remove('loading');
				}
			})
			.fail(function(jqXHR, textStatus, error) {
				console.log( jqXHR.responseText );
				var IS_JSON = true;
				var json;
				try
				{
					json = $.parseJSON(jqXHR.responseText);
				}
				catch(err)
				{
					IS_JSON = false;
				}
				if(IS_JSON) {
					// TODO json errors handling
					console.log("authenticate failed");
					console.log(json);
					$('#error.logon').html('');
					$('#error.join').html(json.message);
					cntEl.classList.remove('loading');
				}
			});
		});

		$("#loginForm").submit(function(event) {
			event.preventDefault();
			cntEl.classList.add('loading');
			var $form = $(this),
				username = $form.find( "input[name='username']" ).val(),
				password = $form.find( "input[name='password']" ).val(),
				url = $form.attr( "action" );
			var posting = $.post( url, { username: username, password: password } );
			posting.done(function( data, textStatus, xhr ) {
				console.log( data );
				if(typeof data =='object') {
					console.log("success JSON");
					var json = data;
					if (json['authenticated']) {
						parent.postMessage({
							type: "loginSuccess",
							loginSuccess: {
								type: 'zarafa',
								zarafa: json['user']
							}
						},
						config.spreedDomain);
					} else {
						$('p.error').html(json.error.message);
					}
				} else {
					console.log("authenticate failed");
					console.log(jQuery(data).find('p.error').html());
					$('#error.join').html('');
					$('#error.logon').html("authentication failed");
					cntEl.classList.remove('loading');
				}
			})
			.fail(function(jqXHR, textStatus, error) {
				console.log( jqXHR.responseText );
				var IS_JSON = true;
				var json;
				try
				{
					json = $.parseJSON(jqXHR.responseText);
				}
				catch(err)
				{
					IS_JSON = false;
				}
				if(IS_JSON) {
					console.log("authenticate failed");
					console.log(json);
					$('#error.join').html('');
					$('#error.logon').html(json.error.message);
					cntEl.classList.remove('loading');
				}
			});
		});
		</script>
	</body>
</html>
